// Step 0: unzip RAR files, convert to txt, and then to dta files

* 0) Preliminaries
*** Cleaning
	clear
	cls
	set more off
	set rmsg on																	// Keeps track of length of process
	
*** Install codes
   ssc install fs
   ssc install confirmdir
   ssc install chunky
   
*** Directories
global unzip "C:\Program Files\7-Zip\7z"				      					// Location of 7z executable program
global loc "CHANGE TO RELEVANT DRIVE"											// CHANGE DRIVE WHERE FORLDERS ARE LOCATED
global raw "$loc\ownership\zip" 												// Location of zip files (SUGGESTION: COPY INTO THIS FOLDER ONLY THE ZIP FILES THAT YOU WANT TO CONVERT. FOR OWNERSHIP PROCESS LINKS FILES & ENTITIES FILE)
global txt "$loc\ownership\txt"													// Output text files
global dta "$loc\ownership\dta"													// Output data files 

global codes "$loc\processing_codes"											// Locataion to save log files
	
// Section 1: Just the Links Files	
* 1) Unzip files
disp "Generate list of individual files to process"
clear
fs "$raw\*.rar"
	return list
set obs 1 
	gen fn = ""
	gen id = 0
foreach f in `r(files)' {
	insobs 1
	local name `f'
	replace fn = "`name'" if _n == _N
}
drop if id == 0
drop if fn == "Entities"
replace id = _n
split fn, p(".") gen(fname)
	keep fname1 id
	rename fname1 fname
	 disp "List of files in processing loop"
	 list fname
save "$loc\ownership\files.dta", replace
	qui sum id
 disp "Beginning to loop 1 through files: saving the data"		
 // First just unzip the files
 forval i = `r(min)'(1)`r(max)'{
	use "$loc\ownership\files.dta", clear
	keep if id == `i'
	global file `=fname[1]'
	 disp "Processing $file"
	// ! tells Stata that command is (in this case) meant to be run through Windows command line
	 disp "Unzip file"
	! "$unzip" e -y "$raw\\$file.rar" -o"$txt\\" -r
}

* 2) Save text files into DTA format
use "$loc\ownership\files.dta", clear			
	qui sum id
forval i = `r(min)'(1)`r(max)'{
	use "$loc\ownership\files.dta", clear
	keep if id == `i'
	global file `=fname[1]'
	 disp "Processing $file"

	 disp "Import text file"
	 chunky using  "$txt\\$file.txt", replace chunksize(2GB) header(include) stub("$txt\chunky\\$file")
		clear
	fs "$txt\chunky\*.txt"
	foreach f in `r(files)' {
		import delimited "$txt\chunky\\`f'", varnames(1) clear
		disp "Save data file: `f'"
		save "$dta\intermediate\\`f'.dta", replace	
		erase "$txt\chunky\\`f'"
	}
}

* 3) Clean up
erase "$loc\ownership\files.dta"

// Section 2: Process the Entities file
* 1) Unzip files
clear
fs "$raw\Entities.rar"
	return list
set obs 1 
	gen fn = ""
	gen id = 0
foreach f in `r(files)' {
	insobs 1
	replace id = id[_n-1] + 1 if _n > 1
	local name `f'
	replace fn = "`name'" if _n == _N
}
drop if id == 0
split fn, p(".") gen(fname)
	keep fname1 id
	rename fname1 fname
	 disp "List of files in processing loop"
	 list fname
save "$loc\ownership\files.dta", replace
	qui sum id
 disp "Beginning to loop 1 through files: saving the data"		
forval i = `r(min)'(1)`r(max)'{
	use "$loc\ownership\files.dta", clear
	keep if id == `i'
	global file `=fname[1]'
	 disp "Processing $file"
	// ! tells Stata that command is (in this case) meant to be run through Windows command line
	 disp "Unzip file"
	! "$unzip" e -y "$raw\\$file.rar" -o"$txt\\" -r

	 disp "Import text file"
	 import delimited "$txt\\$file.txt", varnames(1) clear
	 save "$dta\intermediate\\$file.dta", replace	
	 clear
	}

* 3) Clean up
erase "$loc\ownership\files.dta"
	
